
# this is a job to build a container that can be used to generate revealjs html
# content using md style inputs
revealjs-container:
    before_script:
        # If you are using gitlab's built in container registry, credentials are part of the 
        # job instantiation and can be referenced with variables.
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        # Whatever the name of the job, create a directory named the same way.
        # We will change to that directory
        # This would be the location of the Dockerfile used later to build the docker iamge.
        - cd $CI_JOB_NAME
        # call the docker image used to create other docker images
    image: docker:latest
    variables:
        # DEFINE HOW YOU WOULD LIKE TO NAME THE GENERATED CONTAINER
        FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
    stage: build
    services:
        - docker:dind
    script:
        - docker info
        - docker build --pull -t $FULL_NAME .
        - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
        - docker push $FULL_NAME
    rules:
        - if: $CI_COMMIT_BRANCH == "main"
          changes:
            - revealjs-container/*

# this is to publish pages!
pages:
    stage: deploy
    variables:
        REVEALMD_PATH: the_slides/
    image: 
        name: $CI_REGISTRY_IMAGE/revealjs-container:latest
        entrypoint: [""]
    script:
    # instantiate the docker container, generate html file
    - pwd
    - "ls -la"
    - reveal-md $REVEALMD_PATH --static public
    artifacts:
       paths:
       - public
    rules:
        - if: $CI_COMMIT_BRANCH == "main"